package org.example.lostpet5;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.content.Context;

public class Datos{
	
	private long id;
	private List<Imagen> imagenes;
	private Date fecha;
	private double lat, lng;
	private int tipo, sexo, tamanyo;
	private String raza;
	private String color;
	private String caracteristcas;
	private String descripcion;
	private long id_servidor;
	
	public Datos(){
		this.imagenes=new ArrayList<Imagen>();
		this.fecha=new Date();
		this.tipo=-1;
		this.tamanyo=-1;
		this.sexo=-1;
		this.raza="";
		this.color="";
		this.caracteristcas="";
		this.descripcion="";
		this.lat=0;
		this.lng=0;		
		this.id_servidor=0;
	}
	
	public static Datos obtenerDato(Context context,long id){
		BBDD bd=new BBDD(context);
		return bd.obtenerDato(id);		
	}
	
	public static List<Datos> obtenerDatos(Context context){
		BBDD bd=new BBDD(context);
		return bd.obtenerDatos();
	}
	
	public long getId(){
		return this.id;
	}
	
	public void setId(long id){
		this.id=id;
	}
	
	public List<Imagen> getImagenes(){
		return this.imagenes;
	}
	
	public void setImagenes(List<Imagen> imagenes){
		this.imagenes=imagenes;
	}
	
	public int getTipo(){
		return this.tipo;
	}
	
	public void setTipo(int tipo){
		this.tipo=tipo;
	}
	
	public int getSexo(){
		return this.sexo;
	}
	
	public void setSexo(int sexo){
		this.sexo=sexo;
	}
	
	public int getTamanyo(){
		return this.tamanyo;
	}
	
	public void setTamanyo(int tamanyo){
		this.tamanyo=tamanyo;
	}
	
	public String getRaza(){
		return this.raza;
	}
	
	public void setRaza(String raza){
		this.raza=raza;
	}
	
	public String getColor(){
		return this.color;
	}
	
	public void setColor(String color){
		this.color=color;
	}
	
	public String getCaracteristicas(){
		return this.caracteristcas;
	}
	
	public void setCaracteristicas(String caracteristicas){
		this.caracteristcas=caracteristicas;
	}
	
	public String getDescripcion(){
		return this.descripcion;
	}
	
	public void setDescripcion(String descripcion){
		this.descripcion=descripcion;
	}
	
	public double getLat(){
		return this.lat;
	}
	
	public void setLat(double lat){
		this.lat=lat;
	}
	
	public double getLng(){
		return this.lng;
	}
	
	public void setLng(double lng){
		this.lng=lng;
	}
	
	public Date getFecha(){
		return this.fecha;
	}
	
	public String getFechaFormato(){
		return (new SimpleDateFormat("yyyy-MM-dd HH:mm:ss",Locale.GERMAN).format(this.fecha));		
	}
	
	public void setFecha(Date fecha){
		this.fecha=fecha;
	}

	public long getIdServidor(){
		return this.id_servidor;
	}
	
	public void setIdServidor(long id_servidor){
		this.id_servidor=id_servidor;
	}
	
	public void modificarPosicion(Context context){
		BBDD bd=new BBDD(context);
		bd.actualizarPosicion(this.id, this.lat, this.lng);
	}
	
	public void modificarIdServidor(Context context){
		BBDD bd=new BBDD(context);
		bd.actualizarIdServidor(this.id, id_servidor);
	}
	
	public void eliminarDato(Context context){
		BBDD bd=new BBDD(context);
		bd.eliminarDato(this.id);
	}
	
	public String toJSON() throws JSONException{
		JSONObject obj=new JSONObject();
		obj.put("id",this.id);
		obj.put("tipo",this.tipo);
		obj.put("sexo",this.sexo);
		obj.put("tamanyo",this.tamanyo);
		obj.put("raza",this.raza);
		obj.put("color",this.color);
		obj.put("caracteristicas",this.caracteristcas);
		obj.put("descripcion",this.descripcion);
		obj.put("fecha",getFechaFormato());
		obj.put("lat",this.lat);
		obj.put("lng",this.lng);
		JSONArray array=new JSONArray();
		for(Imagen img : this.imagenes){
			array.put(img.getId());
		}
		obj.put("imagenes", array);		
		return obj.toString();
	}

}
