package org.example.lostpet5;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

public class DialogoConfirmacion extends DialogFragment {
	
	private DialogClickListener callback;
	private String message;
	private String title;
	private String yes;
	private String no;
	private int option;
		
	public DialogoConfirmacion(){
		this.message="";
		this.title="";
		this.yes="";
		this.no="";	
	};
	
	@Override
	public void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
		try{
			callback=(DialogClickListener)getTargetFragment();	
			if(callback==null){
				callback=(DialogClickListener)this.getActivity();
			}				
		}
		catch(ClassCastException e){
			throw new ClassCastException("La clase llamada debe implementar DialogClickListener interface");
		}
	}
	
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState){
    	if(getArguments().containsKey("message"))
			this.message=getArguments().getString("message");
		if(getArguments().containsKey("title"))
			this.title=getArguments().getString("title");
		if(getArguments().containsKey("yes"))
			this.yes=getArguments().getString("yes");
		if(getArguments().containsKey("no"))
			this.no=getArguments().getString("no");
		if(getArguments().containsKey("option"))
			this.option=getArguments().getInt("option");		
        return new AlertDialog.Builder(getActivity())        
        .setMessage(this.message)
        .setTitle(this.title)
        .setIcon(android.R.drawable.ic_dialog_alert)
        .setPositiveButton(this.yes, new DialogInterface.OnClickListener()  {
        	public void onClick(DialogInterface dialog, int id) {        		
        		callback.onYesClick(option);
            }
        })
        .setNegativeButton(this.no, new DialogInterface.OnClickListener() {
        	public void onClick(DialogInterface dialog, int id) {
        		callback.onNoClick(option);
            }
        })
        .create();	         
    }
}
