package org.example.lostpet5;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageButton;
import android.widget.TextView;

public class Sonido extends Fragment{
	
	
	private Activity actividad;
	private ImageButton boton_sonido;
	private TextView descripcion;
	
	@Override
	public void onAttach(Activity actividad){
		super.onAttach(actividad);
		this.actividad=actividad;
	}
	
	public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState) {
		View rootView = inflater.inflate(R.layout.sonido,container, false);
		boton_sonido=(ImageButton)rootView.findViewById(R.id.imageButton1);
		boton_sonido.setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View v) {
				reconocimientoVoz();				
			}			
		});
		descripcion=(TextView) rootView.findViewById(R.id.textView_descripcion_res);
		return rootView;
	}
	
	public void onMyActivityResult(int requestCode, int resultCode, Intent data) {
		if(requestCode == GLOBALES.RECONOZIMINETO_DE_VOZ_REQUEST_CODE && resultCode == Activity.RESULT_OK){
			ArrayList<String> texto=data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
			TextView descripcion=(TextView) this.getView().findViewById(R.id.textView_descripcion_res);
			if(texto.size()>0)
				descripcion.setText(texto.get(0));			
		}
	}
	
	public void reconocimientoVoz(){
		Intent intent=new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
		intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
		//Llamamos desde la actividad a causa del bug
		actividad.startActivityForResult(intent, GLOBALES.RECONOZIMINETO_DE_VOZ_REQUEST_CODE);
	}
	
	public boolean esVacio(){
		return (descripcion.getText().toString().length()==0);
	}
	
	public String getDescripcion(){
		return descripcion.getText().toString();
	}

}
